#include "config.h"
#include "common.h"
#include <stdio.h>
#include <sys/types.h>
#include "sendcmd.h"
#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#if HAVE_SYS_PARAM_H
# include <sys/param.h>
#else
#define MAXPATHLEN 256
#endif

extern int verbose;

u_char
str_to_makercode(str)
char *str;
{
  if((str == NULL) || (*str == '\0'))
    return(0xff);
  if(strcasecmp(str, "victor_tv_a") == 0)
    return(VICTOR_TV_A);
  else if(strcasecmp(str, "victor_tv_b") == 0)
    return(VICTOR_TV_B);
  else if(strcasecmp(str, "victor_tv_c") == 0)
    return(VICTOR_TV_C);
  else if(strcasecmp(str, "victor_vtr_a") == 0)
    return(VICTOR_VTR_A);
  else if(strcasecmp(str, "victor_vtr_b") == 0)
    return(VICTOR_VTR_B);
  else if(strcasecmp(str, "victor_vtr_c") == 0)
    return(VICTOR_VTR_C);
  else if(strcasecmp(str, "sanyo_tv_a") == 0)
    return(SANYO_TV_A);
  else if(strcasecmp(str, "sanyo_tv_b") == 0)
    return(SANYO_TV_B);
  else if(strcasecmp(str, "sanyo_tv_c") == 0)
    return(SANYO_TV_C);
  else if(strcasecmp(str, "sanyo_vtr_a") == 0)
    return(SANYO_VTR_A);
  else if(strcasecmp(str, "sanyo_vtr_b") == 0)
    return(SANYO_VTR_B);
  else if(strcasecmp(str, "sanyo_vtr_c") == 0)
    return(SANYO_VTR_C);
  else if(strcasecmp(str, "sanyo_vtr_d") == 0)
    return(SANYO_VTR_D);
  else if(strcasecmp(str, "sharp_tv_a") == 0)
    return(SHARP_TV_A);
  else if(strcasecmp(str, "sharp_tv_b") == 0)
    return(SHARP_TV_B);
  else if(strcasecmp(str, "sharp_vtr_a") == 0)
    return(SHARP_VTR_A);
  else if(strcasecmp(str, "sharp_vtr_b") == 0)
    return(SHARP_VTR_B);
  else if(strcasecmp(str, "sharp_vtr_c") == 0)
    return(SHARP_VTR_C);
  else if(strcasecmp(str, "fgeneral_tv_a") == 0)
    return(FGENERAL_TV_A);
  else if(strcasecmp(str, "fgeneral_tv_b") == 0)
    return(FGENERAL_TV_B);
  else if(strcasecmp(str, "sony_tv") == 0)
    return(SONY_TV);
  else if(strcasecmp(str, "sony_vtr_a") == 0)
    return(SONY_VTR_A);
  else if(strcasecmp(str, "sony_vtr_b") == 0)
    return(SONY_VTR_B);
  else if(strcasecmp(str, "sony_vtr_c") == 0)
    return(SONY_VTR_C);
  else if(strcasecmp(str, "toshiba_tv") == 0)
    return(TOSHIBA_TV);
  else if(strcasecmp(str, "toshiba_vtr_a") == 0)
    return(TOSHIBA_VTR_A);
  else if(strcasecmp(str, "toshiba_vtr_b") == 0)
    return(TOSHIBA_VTR_B);
  else if(strcasecmp(str, "nec_tv") == 0)
    return(NEC_TV);
  else if(strcasecmp(str, "nec_vtr_a") == 0)
    return(NEC_VTR_A);
  else if(strcasecmp(str, "nec_vtr_b") == 0)
    return(NEC_VTR_B);
  else if(strcasecmp(str, "hitachi_tv") == 0)
    return(HITACHI_TV);
  else if(strcasecmp(str, "hitachi_vtr_a") == 0)
    return(HITACHI_VTR_A);
  else if(strcasecmp(str, "hitachi_vtr_b") == 0)
    return(HITACHI_VTR_B);
  else if(strcasecmp(str, "matsushita_tv_a") == 0)
    return(MATSUSHITA_TV_A);
  else if(strcasecmp(str, "matsushita_tv_b") == 0)
    return(MATSUSHITA_TV_B);
  else if(strcasecmp(str, "matsushita_vtr_a") == 0)
    return(MATSUSHITA_VTR_A);
  else if(strcasecmp(str, "matsushita_vtr_b") == 0)
    return(MATSUSHITA_VTR_B);
  else if(strcasecmp(str, "matsushita_vtr_c") == 0)
    return(MATSUSHITA_VTR_C);
  else if(strcasecmp(str, "mitsubishi_tv") == 0)
    return(MITSUBISHI_TV);
  else if(strcasecmp(str, "mitsubishi_vtr_a") == 0)
    return(MITSUBISHI_VTR_A);
  else if(strcasecmp(str, "mitsubishi_vtr_b") == 0)
    return(MITSUBISHI_VTR_B);
  else if(strcasecmp(str, "mitsubishi_vtr_c") == 0)
    return(MITSUBISHI_VTR_C);
  else if(strcasecmp(str, "mitsubishi_vtr_d") == 0)
    return(MITSUBISHI_VTR_D);
  else{
    fprintf(stderr,"unknown maker '%s'.\n", str);
    return(0xFF);
  }
}

u_char
str_to_operationcode(makercode, str)
u_char makercode;
char *str;
{
  if((str == NULL) || (*str == '\0'))
    return(0xff);

  if(makercode & 0x08) {
    if(strncasecmp(str, "power", 3) == 0)
      return(VTR_POWER);
    else if(strncasecmp(str, "rew", 3) == 0)
      return(VTR_REW);
    else if(strncasecmp(str, "play", 2) == 0)
      return(VTR_PLAY);
    else if(strncasecmp(str, "ff", 2) == 0)
      return(VTR_FF);
    else if(strncasecmp(str, "rec", 3) == 0)
      return(VTR_REC);
    else if(strncasecmp(str, "stop", 2) == 0)
      return(VTR_STOP);
    else if(strncasecmp(str, "pause", 2) == 0)
      return(VTR_PAUSE);
    else if(strncasecmp(str, "ch_up", 4) == 0)
      return(VTR_CH_UP);
    else if(strncasecmp(str, "ch_+", 4) == 0)
      return(VTR_CH_UP);
    else if(strncasecmp(str, "ch_down", 4) == 0)
      return(VTR_CH_DOWN);
    else if(strncasecmp(str, "ch_-", 4) == 0)
      return(VTR_CH_DOWN);
    else if(strncasecmp(str, "select", 2) == 0)
      return(VTR_SELECT);
    else {
      fprintf(stderr,"unknown VTR operation '%s'.\n", str);
      return(0xff);
    }
  } else {
    if(strncasecmp(str, "power", 3) == 0)
      return(TV_POWER);
    else if(strncasecmp(str, "ch_up", 4) == 0)
      return(TV_CH_UP);
    else if(strncasecmp(str, "ch_+", 4) == 0)
      return(TV_CH_UP);
    else if(strncasecmp(str, "ch_down", 4) == 0)
      return(TV_CH_DOWN);
    else if(strncasecmp(str, "ch_-", 4) == 0)
      return(TV_CH_DOWN);
    else if(strncasecmp(str, "vol_up", 5) == 0)
      return(TV_VOL_UP);
    else if(strncasecmp(str, "vol_+", 5) == 0)
      return(TV_VOL_UP);
    else if(strncasecmp(str, "vol_down", 5) == 0)
      return(TV_VOL_DOWN);
    else if(strncasecmp(str, "vol_-", 5) == 0)
      return(TV_VOL_DOWN);
    else if(strncasecmp(str, "select", 2) == 0)
      return(TV_SELECT);
    else {
      fprintf(stderr,"unknown TV operation '%s'.\n", str);
      return(0xff);
    }
  }
}

int parsefile(fp)
FILE *fp;
{
  char buf[256];
  char dir[MAXPATHLEN];
  char buf1[256];
  char buf2[MAXPATHLEN];

  u_char makercode;
  dir[0] = '\0';
  while(fgets(buf, 256, fp)){
    switch(buf[0]){
    case '#': /* comment */
      break;
    case '%':
      if(strncasecmp(&buf[1], "dir", 3) == 0){
	if(sscanf(buf, "%s %s", buf1, dir) < 2){
	  fprintf(stderr,"Syntax error at '%%dir dirpath' keyword\n");
	}
      } else if(strncasecmp(&buf[1], "wait", 4) == 0){
	if(sscanf(buf, "%s %s", buf1, buf2) < 2){
	  fprintf(stderr,"Syntax error at '%%wait second' keyword\n");
	}
	if(verbose)
	  fprintf(stderr, "WAIT %d\n", atoi(buf2));
	sleep(atoi(buf2));
      }
      break;
    default:
      switch(sscanf(buf, "%s %s", buf1, buf2)){
      case 1: /* recorded data */
	if(buf1[0] != '/')
	  sprintf(buf2, "%s/%s", dir, buf1);
	else
	  sprintf(buf2, "%s", buf1);
	IRsendRemocomMode();
	sendRecordedData(buf2);
	usleep(WAITTIME); /* ?? */
	break;
      case 2: /* preset data */
	makercode = str_to_makercode(buf1);
	IRpresetRemocomMode();
	sendPresetCommand(makercode, buf2);
	usleep(WAITTIME); /* ?? */
	break;
      default:
	/* do nothing */
	break;
      }
      break;
    }
  }
}
